import es, playerlib, services, os.path, langlib, cfglib, gamethread, usermsg, popuplib

info = es.AddonInfo()
info.name = 'LooneyChat'
info.version = '1.4'
info.url = 'http://forums.mattie.info/cs/forums/viewtopic.php?t=26133'
info.author = 'Satoon101'
es.ServerVar('looneychat_version',info.version,'looneychat_version').makepublic()

addonpath = es.getAddonPath('looneychat')
config = cfglib.AddonCFG(addonpath + '/lc_config.cfg')
config.text('***************************\n// ** AUTH_Provider Options **\n// ***************************')
looney_admins = config.cvar('looney_admins','',"There are 3 ways to add Admins, 1st is to use an Auth_Provider in Eventscripts\n// 2nd is to use your Mani_Admin_Plugin clients.txt file\n// and third is to add SteamID's below in format:\n//\n// looney_admins \"STEAM_0:1:1234567,STEAM_0:1:7654321,etc...\"")
config.text('\n')
config.text('********************************\n// ** LooneyChat Command Options **\n// ********************************')
looney_admin_admin = config.cvar('looney_admin_admin','@others','Set to text for Admin to Admins Speech (change only text inside "")\n// To disable the command, set as ""')
looney_admin_player = config.cvar('looney_admin_player','@player','Set to text for Admin to Player Speech (change only text inside "")\n// Can also be used to send messages to any specific Admin\n// To disable the command, set as ""')
looney_player_admin = config.cvar('looney_player_admin','@admin','Set to text for Player to Admins Speech (change only text inside "")\n// To disable the command, set as ""')
looney_admin_list = config.cvar('looney_admin_list','','Set to command for AdminList\n// To disable, set to ""')
lc_adminlist_cmd_type = config.cvar('lc_adminlist_cmd_type',1,'When using AdminList command, how to display\n// 0 = Chat text, 1 = Popup')
lc_adminlist_cmd_group = config.cvar('lc_adminlist_cmd_group',3,'0 = No one can use command, 1 = non-Admins can use command, 2 = Admins can use command, 3 = ALL Players can use command')
config.text('\n')
config.text('*********************************\n// ** ADMINS SEE ALL TEXT Options **\n// *********************************')
lc_alltext = config.cvar('lc_alltext',1,'0 = Disable See All Text, 1 = Admins See All Text, 2 = All Players See All Text\n// If set to 2, non-admins will still not see messages not intended for them used via commands')
lc_showteamonly = config.cvar('lc_showteamonly',1,'Enable/Disable show teamonly chat to other teams with lc_alltext')
lc_filterlist = config.cvar('lc_filterlist','',"Put in any commands (such as !rank, timeleft, ff, etc...) you wish to be filtered from See All Text\n// Use the following format to add filtered commands:\n//\n// lc_filterlist \"!rank,timeleft,ff,etc...\"")
lc_headerfilter = config.cvar('lc_headerfilter','',"Put in any headers, (such as @, !, #, etc...) that start commands, you wish to be filtered from See All Text\n// Use single characters only!!!  Use the following format to add filtered headers:\n//\n// lc_headerfilter \"@,!,#,etc...\"")
config.text('\n')
config.text('*******************************\n// ** ANNOUNCE COMMANDS Options **\n// *******************************')
lc_announcements = config.cvar('lc_announcements',1,'0 = No Announcements, 1 = Announce using Rounds, 2 = Announce using Time')
lc_admin_announce = config.cvar('lc_admin_announce',3,'Set to number of rounds/minutes between announce to Admins about Admin Commands (0 = No Announcement)')
lc_player_announce = config.cvar('lc_player_announce',3,'Set to number of rounds/minutes between announce to Players about Player Commands (0 = No Announcement)')
lc_adminlist_announce = config.cvar('lc_adminlist_announce',3,'Set to number of rounds/minutes between announcing online Admins (0 = No Announcement)')
lc_adminlist_announce_type = config.cvar('lc_adminlist_announce_type',1,'When announcing AdminList, how to display\n// 0 = Chat text, 1 = Popup')
lc_adminlist_announce_group = config.cvar('lc_adminlist_announce_group',1,'0 = No announcement for Online Admins, 1 = Announce only to non-Admins, 2 = Announce only to Admins, 3 = Announce to ALL Players')
lc_adminlist_cmd_announce = config.cvar('lc_adminlist_cmd_announce',3,'Set to number of rounds/minutes between announcing AdminList command\n// It will only be announced to players who can use the command (0 = No Announcement)')
config.write()
lc_lang = langlib.Strings(addonpath + '/strings.ini')

teamnames = {0:'un',1:'spec',2:'t',3:'ct'}
lc_round_count = {'admin':0,'player':0,'list':0,'cmd':0}
lc_list = ['admin','player','list','cmd']
lc_commands = []
lc_server_admins = []
PlayerList = {}
AdminList = []
NonAdminList = []

class Player:
    def __init__(self,userid):
        self.userid = str(userid)
        user = playerlib.getPlayer(self.userid)
        self.lang = user.get('lang')
        self.isbot = user.get('isbot')
        self.index = user.get('index')
        self.admin = ruAdmin(self.userid)
        if self.admin and not self.userid in AdminList:
            AdminList.append(self.userid)
        elif not self.userid in NonAdminList and not self.isbot:
            NonAdminList.append(self.userid)
    
    def announcements(self,annotype):
        if self.isbot: return
        if annotype == 'admin' and self.admin:
            for x in [looney_admin_admin,looney_admin_player]:
                if str(x):
                    es.tell(self.userid,'#multi',lc_lang('Ad2Ad' if x == looney_admin_admin else 'Ad2Pl',{'command':x},self.lang))
        if annotype == 'player' and not self.admin and str(looney_player_admin):
            es.tell(self.userid,'#multi',lc_lang('Pl2Ad',{'command':looney_player_admin},self.lang))
        if annotype == 'list' and ((lc_adminlist_announce_group in [1,3] and not self.admin) or (lc_adminlist_announce_group in [2,3] and self.admin)):
            self.sendAdminList(lc_adminlist_announce_type)
        if annotype == 'cmd' and str(looney_admin_list) and ((lc_adminlist_cmd_group in [1,3] and not self.admin) or (lc_adminlist_cmd_group in [2,3] and self.admin)):
            es.tell(self.userid,'#multi',lc_lang('Online Command',{'command':looney_admin_list},self.lang))
    
    def sendAdminList(self,style):
        total_admins = len(AdminList)
        if total_admins == 1 and self.admin:
            es.tell(self.userid,'#multi',lc_lang('No Others',self.lang))
        elif total_admins:
            if int(style):
                adminpopup = popuplib.easymenu(lc_lang('Online Popup',self.lang),'choice',None)
                for x in AdminList:
                    adminpopup.addoption(x,es.getplayername(x))
                adminpopup.timeout('view',10)
                adminpopup.send(self.userid)
            else:
                text = es.getplayername(AdminList[0])
                for x in range(1,total_admins):
                    text = '%s#default,#lightgreen %s'%(text,es.getplayername(AdminList[x]))
                es.tell(self.userid,'#multi',lc_lang('Online Admins',{'admins':text},self.lang))
        else:
            es.tell(self.userid,'#multi',lc_lang('No Admins',self.lang))
    
    def isCmdAllowed(self):
        if lc_adminlist_cmd_group in [1,3] and not self.admin: return(True)
        if lc_adminlist_cmd_group in [2,3] and self.admin: return(True)
        return(False)
    
    def commands(self,command,args=()):
        start = 0 if command != looney_admin_player else 1
        words = 0 if args == ['None'] else len(args)
        if (self.admin and command != looney_player_admin) or (not self.admin and command == looney_player_admin):
            if words > start:
                name = es.getplayername(self.userid)
                text = args[start]
                for x in range(start + 1,len(args)):
                    text = '%s %s'%(text,args[x])
                if command == looney_admin_player:
                    playername = args[0]
                    player = es.getuserid(playername)
                    if not player or PlayerList[str(player)].isbot:
                        es.tell(self.userid,'#multi',lc_lang('Invalid Player',{'playername':playername},self.lang) if not player else lc_lang('BOT',{'playername':es.getplayername(player)},self.lang))
                    else:
                        usermsg.saytext2(player,self.index,reslash(lc_lang('Admin to Player',{'sender':name,'text':text},PlayerList[str(player)].lang)))
                else:
                    admins = len(AdminList)
                    if (admins and not self.admin) or admins > 1:
                        for admin in AdminList:
                            if admin != self.userid:
                                usermsg.saytext2(admin,self.index,reslash(lc_lang('Admin to Admins' if self.admin else 'Player to Admins',{'sender':name,'text':text},PlayerList[admin].lang)))
                    else:
                        es.tell(self.userid,'#multi',lc_lang('No Others' if self.admin else 'No Admins',self.lang))
            else:
                es.tell(self.userid,'#multi',lc_lang('Syntax2' if start else 'Syntax1',{'command':command},self.lang))
        else:
            es.tell(self.userid,'#multi',lc_lang('PlayersOnly' if self.admin else 'AdminOnly',{'command':command},self.lang))
    
    def allChat(self,name,text,teamonly,isdead,team):
        if not lc_alltext in [1,2] or text in str(lc_filterlist).split(','): return
        if es.exists('saycommand',text.split(' ')[0]): return
        if text.replace('"','')[0] in str(lc_headerfilter).split(','): return
        userstatus = 'SPEC' if team == 1 else 'DEAD' if isdead else 'ALIVE'
        if teamonly:
            for x in teamnames:
                if x != team and int(lc_showteamonly):
                    self.sendmessage(name,userstatus,text,teamnames[x])
            if isdead:
                self.sendmessage(name,userstatus,text,'alive,#%s'%teamnames[team])
        elif isdead or not team in [2,3]:
            for x in [2,3]:
                self.sendmessage(name,userstatus,text,'alive,#%s'%teamnames[x])
    
    def sendmessage(self,name,userstatus,text,team):
        for userid in playerlib.getUseridList('#human,#%s'%team):
            player = PlayerList[str(userid)]
            if self.userid != player.userid and (lc_alltext == 2 or player.admin):
                usermsg.saytext2(userid,self.index,reslash(lc_lang(userstatus,{'sender':name,'text':text},player.lang)))

def load():
    config.execute()
    gamethread.delayed(0,settings)

def settings():
    for x in [looney_admin_admin,looney_admin_player,looney_player_admin]:
        if not str(x): continue
        if not es.exists('saycommand',x):
            lc_commands.append(x)
            es.regsaycmd(x,'looneychat/looneycommands','LooneyChat Commands')
        else:
            es.dbgmsg(0,'%s is already a command'%x)
    find_Admins()
    if lc_announcements == 2:
        for x in lc_list:
            check_announce(x)
    for userid in es.getUseridList():
        default(str(userid))

def check_announce(name):
    if int(lc_admin_announce) and (str(looney_admin_player) or str(looney_admin_admin)) and name == 'admin':
        gamethread.delayedname(lc_admin_announce * 60,name,check_announcement,name)
    if int(lc_player_announce) and str(looney_player_admin) and name == 'player':
        gamethread.delayedname(lc_player_announce * 60,name,check_announcement,name)
    if int(lc_adminlist_announce) and int(lc_adminlist_announce_group) and name == 'list':
        gamethread.delayedname(lc_adminlist_announce * 60,name,check_announcement,name)
    if int(lc_adminlist_cmd_announce) and str(looney_admin_list) and name == 'cmd':
        gamethread.delayedname(lc_adminlist_cmd_announce * 60,name,check_announcement,name)

def find_Admins():
    global ruAdmin
    mani_file = es.ServerVar('eventscripts_gamedir') + '/cfg/mani_admin_plugin/clients.txt'
    if os.path.isfile(mani_file):
        a = open(mani_file, 'r')
        b = a.readlines()
        a.close()
        for c in b:
            c = c.replace('\t','').replace(' ','').replace('\n','')
            if '"steam""STEAM_' in c:
                lc_server_admins.append(c.replace('"steam""', '').replace('"', ''))
    for x in str(looney_admins).replace("'",'').split(','):
        if not x in lc_server_admins:
            lc_server_admins.append(x)
    if services.isRegistered('auth'):
        auth = services.use('auth')
        auth.registerCapability('looneychat', auth.ADMIN)
        ruAdmin = lambda x: auth.isUseridAuthorized(x,'looneychat') or es.getplayersteamid(x) in lc_server_admins
    else:
        ruAdmin = lambda x: es.getplayersteamid(x) in lc_server_admins

def es_map_start(ev):
    for userid in es.getUseridList():
        default(str(userid))

def player_activate(ev):
    default(ev['userid'])

def default(userid):
    if not userid in PlayerList:
        PlayerList[userid] = Player(userid)

def round_start(ev):
    for x in lc_list:
        check_announcement(x)

def dod_round_start(ev):
    for x in lc_list:
        check_announcement(x)

def teamplay_round_start(ev):
    for x in lc_list:
        check_announcement(x)

def check_announcement(name):
    if not int(lc_announcements): return
    types = {'admin':{'rounds':lc_admin_announce,'true':looney_admin_player if str(looney_admin_player) else looney_admin_admin},
             'player':{'rounds':lc_player_announce,'true':looney_player_admin},
             'list':{'rounds':lc_adminlist_announce,'true':'yes' if int(lc_adminlist_announce_group) else ''},
             'cmd':{'rounds':lc_adminlist_cmd_announce,'true':looney_admin_list}}
    if lc_announcements == 1 and int(types[name]['rounds']) and str(types[name]['true']):
        lc_round_count[name] += 1
    elif lc_announcements == 2:
        check_announce(name)
    if lc_announcements == 2 or lc_round_count[name] == types[name]['rounds'] != 0:
        lc_round_count[name] = 0
        for userid in PlayerList:
            PlayerList[userid].announcements(name)

def player_disconnect(ev):
    userid = ev['userid']
    if userid in PlayerList:
        del PlayerList[userid]
    if userid in AdminList:
        AdminList.remove(userid)
    if userid in NonAdminList:
        NonAdminList.remove(userid)

def looneycommands():
    PlayerList[str(es.getcmduserid())].commands(es.getargv(0),str(es.getargs()).split(' '))
    
def es_player_chat(ev):
    PlayerList[ev['userid']].allChat(ev['es_username'],ev['text'],int(ev['teamonly']),int(ev['es_userdead']),int(ev['es_userteam']))

def reslash(text):
    text = text.replace(r'\1','\1').replace(r'\2','\2').replace(r'\3','\3').replace(r'\4','\4')
    lc_text = text[1:~0] if text.startswith('"') and text.endswith('"') else text
    return lc_text

def sayFilter(userid,text,teamonly):
    if text.replace('"','') == looney_admin_list and str(userid) in PlayerList:
        player = PlayerList[str(userid)]
        if player.isCmdAllowed():
            player.sendAdminList(lc_adminlist_cmd_type)
            return(0,None,0)
    for x in lc_commands:
        if text.startswith('"%s'%x):
            return(userid,text[1:~0],teamonly)
    return(userid,text,teamonly)

es.addons.registerSayFilter(sayFilter)

def unload():
    for x in lc_list:
        gamethread.cancelDelayed(x)
    for x in lc_commands:
        es.unregsaycmd(x)
    es.addons.unregisterSayFilter(sayFilter)